com.fasterxml.jackson.databind.ser.std

## Class ReferenceTypeSerializer<T>

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonSerializer<T>
  - - com.fasterxml.jackson.databind.ser.std.StdSerializer<T>
    - - com.fasterxml.jackson.databind.ser.std.ReferenceTypeSerializer<T>

All Implemented Interfaces:
  JsonFormatVisitable, SchemaAware, ContextualSerializer, Serializable

Direct Known Subclasses:
  AtomicReferenceSerializer

    public abstract class ReferenceTypeSerializer<T>
    extends StdSerializer<T>
    implements ContextualSerializer

Base implementation for values of `ReferenceType`. Implements most of functionality, only leaving couple of abstract methods for sub-classes to implement

Since:
  2.8
See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonSerializer

`JsonSerializer.None`

### Field Summary

Fields
`protected JsonInclude.Include` `_contentInclusion` Further guidance on serialization-inclusion (or not), regarding contained value (if any).
`protected PropertySerializerMap` `_dynamicSerializers` If element type can not be statically determined, mapping from runtime type to serializer is handled using this object
`protected BeanProperty` `_property`
`protected JavaType` `_referredType` Value type
`protected NameTransformer` `_unwrapper` In case of unwrapping, need name transformer.
`protected JsonSerializer<Object>` `_valueSerializer` Serializer for content values, if statically known.
`protected TypeSerializer` `_valueTypeSerializer` Type serializer used for values, if any.

### Fields inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

`_handledType`

### Constructor Summary

Constructors
`` `ReferenceTypeSerializer(ReferenceType fullType, boolean staticTyping, TypeSerializer vts, JsonSerializer<Object> ser)`
`protected` `ReferenceTypeSerializer(ReferenceTypeSerializer<?> base, BeanProperty property, TypeSerializer vts, JsonSerializer<?> valueSer, NameTransformer unwrapper, JsonInclude.Include contentIncl)`

### Method Summary

Methods
`protected abstract Object` `_getReferenced(T value)`
`protected abstract Object` `_getReferencedIfPresent(T value)`
`protected abstract boolean` `_isValueEmpty(T value)`
`protected boolean` `_useStatic(SerializerProvider provider, BeanProperty property, JavaType referredType)`
`void` `acceptJsonFormatVisitor(JsonFormatVisitorWrapper visitor, JavaType typeHint)` Default implementation specifies no format.
`JsonSerializer<?>` `createContextual(SerializerProvider provider, BeanProperty property)` Method called to see if a different (or differently configured) serializer is needed to serialize values of specified property.
`boolean` `isEmpty(SerializerProvider provider, T value)` Method called to check whether given serializable value is considered "empty" value (for purposes of suppressing serialization of empty values).
`boolean` `isUnwrappingSerializer()` Accessor for checking whether this serializer is an "unwrapping" serializer; this is necessary to know since it may also require caller to suppress writing of the leading property name.
`void` `serialize(T ref, JsonGenerator g, SerializerProvider provider)` Method that can be called to ask implementation to serialize values of type this serializer handles.
`void` `serializeWithType(T ref, JsonGenerator g, SerializerProvider provider, TypeSerializer typeSer)` Method that can be called to ask implementation to serialize values of type this serializer handles, using specified type serializer for embedding necessary type information.
`JsonSerializer<T>` `unwrappingSerializer(NameTransformer transformer)` Method that will return serializer instance that produces "unwrapped" serialization, if applicable for type being serialized (which is the case for some serializers that produce JSON Objects as output).
`protected abstract ReferenceTypeSerializer<T>` `withResolved(BeanProperty prop, TypeSerializer vts, JsonSerializer<?> valueSer, NameTransformer unwrapper, JsonInclude.Include contentIncl)`

### Methods inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

`createObjectNode, createSchemaNode, createSchemaNode, findAnnotatedContentSerializer, findConvertingContentSerializer, findFormatFeature, findFormatOverrides, findIncludeOverrides, findPropertyFilter, getSchema, getSchema, handledType, isDefaultSerializer, visitArrayFormat, visitArrayFormat, visitFloatFormat, visitIntFormat, visitIntFormat, visitStringFormat, visitStringFormat, wrapAndThrow, wrapAndThrow`

### Methods inherited from class com.fasterxml.jackson.databind.JsonSerializer

`getDelegatee, isEmpty, properties, replaceDelegatee, usesObjectId, withFilterId`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### _referredType

    protected final JavaType _referredType

Value type

#### _property

    protected final BeanProperty _property

#### _valueTypeSerializer

    protected final TypeSerializer _valueTypeSerializer

Type serializer used for values, if any.

#### _valueSerializer

    protected final JsonSerializer<Object> _valueSerializer

Serializer for content values, if statically known.

#### _unwrapper

    protected final NameTransformer _unwrapper

In case of unwrapping, need name transformer.

#### _contentInclusion

    protected final JsonInclude.Include _contentInclusion

Further guidance on serialization-inclusion (or not), regarding contained value (if any).

#### _dynamicSerializers

    protected transient PropertySerializerMap _dynamicSerializers

If element type can not be statically determined, mapping from runtime type to serializer is handled using this object

### Constructor Detail

#### ReferenceTypeSerializer

    public ReferenceTypeSerializer(ReferenceType fullType,
                           boolean staticTyping,
                           TypeSerializer vts,
                           JsonSerializer<Object> ser)

#### ReferenceTypeSerializer

    protected ReferenceTypeSerializer(ReferenceTypeSerializer<?> base,
                           BeanProperty property,
                           TypeSerializer vts,
                           JsonSerializer<?> valueSer,
                           NameTransformer unwrapper,
                           JsonInclude.Include contentIncl)

### Method Detail

#### unwrappingSerializer

    public JsonSerializer<T> unwrappingSerializer(NameTransformer transformer)

Description copied from class: `JsonSerializer`
Method that will return serializer instance that produces "unwrapped" serialization, if applicable for type being serialized (which is the case for some serializers that produce JSON Objects as output). If no unwrapped serializer can be constructed, will simply return serializer as-is.

Default implementation just returns serializer as-is, indicating that no unwrapped variant exists

Overrides:
  `unwrappingSerializer` in class `JsonSerializer<T>`
Parameters:
  `transformer` - Name transformation to use to convert between names of unwrapper properties

#### withResolved

    protected abstract ReferenceTypeSerializer<T> withResolved(BeanProperty prop,
                                          TypeSerializer vts,
                                          JsonSerializer<?> valueSer,
                                          NameTransformer unwrapper,
                                          JsonInclude.Include contentIncl)

#### _isValueEmpty

    protected abstract boolean _isValueEmpty(T value)

#### _getReferenced

    protected abstract Object _getReferenced(T value)

#### _getReferencedIfPresent

    protected abstract Object _getReferencedIfPresent(T value)

#### createContextual

    public JsonSerializer<?> createContextual(SerializerProvider provider,
                                     BeanProperty property)
                                       throws JsonMappingException

Description copied from interface: `ContextualSerializer`
Method called to see if a different (or differently configured) serializer is needed to serialize values of specified property. Note that instance that this method is called on is typically shared one and as a result method should NOT modify this instance but rather construct and return a new instance. This instance should only be returned as-is, in case it is already suitable for use.

Specified by:
  `createContextual` in interface `ContextualSerializer`
Parameters:
  `provider` - Serializer provider to use for accessing config, other serializers
  `property` - Method or field that represents the property (and is used to access value to serialize). Should be available; but there may be cases where caller can not provide it and null is passed instead (in which case impls usually pass 'this' serializer as is)
Returns:
  Serializer to use for serializing values of specified property; may be this instance or a new instance.
Throws:
  `JsonMappingException`

#### _useStatic

    protected boolean _useStatic(SerializerProvider provider,
                     BeanProperty property,
                     JavaType referredType)

#### isEmpty

    public boolean isEmpty(SerializerProvider provider,
                  T value)

Description copied from class: `JsonSerializer`
Method called to check whether given serializable value is considered "empty" value (for purposes of suppressing serialization of empty values).

Default implementation will consider only null values to be empty.

NOTE: replaces `JsonSerializer.isEmpty(Object)`, which was deprecated in 2.5

Overrides:
  `isEmpty` in class `JsonSerializer<T>`

#### isUnwrappingSerializer

    public boolean isUnwrappingSerializer()

Description copied from class: `JsonSerializer`
Accessor for checking whether this serializer is an "unwrapping" serializer; this is necessary to know since it may also require caller to suppress writing of the leading property name.

Overrides:
  `isUnwrappingSerializer` in class `JsonSerializer<T>`

#### serialize

    public void serialize(T ref,
                 JsonGenerator g,
                 SerializerProvider provider)
                   throws IOException

Description copied from class: `JsonSerializer`
Method that can be called to ask implementation to serialize values of type this serializer handles.

Specified by:
  `serialize` in class `StdSerializer<T>`
Parameters:
  `ref` - Value to serialize; can not be null.
  `g` - Generator used to output resulting Json content
  `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
Throws:
  `IOException`

#### serializeWithType

    public void serializeWithType(T ref,
                         JsonGenerator g,
                         SerializerProvider provider,
                         TypeSerializer typeSer)
                           throws IOException

Description copied from class: `JsonSerializer`
Method that can be called to ask implementation to serialize values of type this serializer handles, using specified type serializer for embedding necessary type information.

Default implementation will throw `UnsupportedOperationException` to indicate that proper type handling needs to be implemented.

For simple datatypes written as a single scalar value (JSON String, Number, Boolean), implementation would look like:

      // note: method to call depends on whether this type is serialized as JSON scalar, object or Array!
      typeSer.writeTypePrefixForScalar(value, gen);
      serialize(value, gen, provider);
      typeSer.writeTypeSuffixForScalar(value, gen);

and implementations for type serialized as JSON Arrays or Objects would differ slightly, as `START-ARRAY`/`END-ARRAY` and `START-OBJECT`/`END-OBJECT` pairs need to be properly handled with respect to serializing of contents.

Overrides:
  `serializeWithType` in class `JsonSerializer<T>`
Parameters:
  `ref` - Value to serialize; can not be null.
  `g` - Generator used to output resulting Json content
  `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
  `typeSer` - Type serializer to use for including type information
Throws:
  `IOException`

#### acceptJsonFormatVisitor

    public void acceptJsonFormatVisitor(JsonFormatVisitorWrapper visitor,
                               JavaType typeHint)
                                 throws JsonMappingException

Description copied from class: `StdSerializer`
Default implementation specifies no format. This behavior is usually overriden by custom serializers.

Specified by:
  `acceptJsonFormatVisitor` in interface `JsonFormatVisitable`
Overrides:
  `acceptJsonFormatVisitor` in class `StdSerializer<T>`
  `typeHint` - Type of element (entity like property) being visited
Throws:
  `JsonMappingException`